/*
 *  InitialGuessFile.h
 *  fico
 *
 *  Created by Jose H. Garcia on 8/9/06.
 *  Copyright 2006 NCAR/HAO. All rights reserved.
 *
 */

#ifndef InitialGuessFile_h_
#define InitialGuessFile_h_

#include <string>
#include <fstream>
#include <vector>

#include "MERLIN_Model.h"

// This protects the compilation
// on Solaris 10 using gcc 3.4.3
#ifdef _B
#undef _B
#endif

using namespace std;
using namespace CSAC;

class  InitialGuessFile
{
protected:
	string _type;
	string _name;
	std::vector<float> _B;
	std::vector<float> _ruff_B;
	std::vector<float> _Inclination;
	std::vector<float> _Azimuth;
	std::vector<float> _Eta0;
	std::vector<float> _Damp;
	std::vector<float> _Dop;
	std::vector<float> _B0;
	std::vector<float> _B1;
	std::vector< vector <float> > _lines_shift;
	std::vector<float> _stray_light;
	std::vector<float> _stray_light_shift;
public:
		InitialGuessFile(const string &f);
	virtual ~InitialGuessFile() {};
	virtual bool open() throw () = 0;
	virtual string get_name() {return _name;}
	virtual void load_guess_at_pixel(int , MERLIN_Model &);
	virtual void load_ruff_guess_at_pixel(int , MERLIN_Model &);
	virtual void load_contents() throw (string) = 0;
};





#endif //  InitialGuessFile_h_
