#include <string.h>
#include <stdlib.h>

#include "MERLIN_FFTW_ST.h"

#include <iostream>
using namespace std;

extern "C"
{
    void realft_FFTW(double data[], unsigned long nn, int isign) {
        
        long jj;
        long i;
        double *data_ = data +1 ;
        double *input = 0;
        const MERLIN_FFTW_ST *mfftw = MERLIN_FFTW_ST::instanceOf();

        
        input = (double*)fftw_malloc(sizeof(double) * nn);
        if(input==0)
            exit(1);

        /* Create FFT plan from input into output using real to real (r2r) plan to mimic realft. */
        if(isign == 1) 
        {
            mfftw->execute(data_, nn, input);
            // reorganize as it is expected by MERLIN, that is,
            // matching the order of Numerical Recipes.
            int half = nn/2;
            int index;
            data_[0]=input[0];
            data_[1]=input[half];
            for(i = 0; i < (half -1); i++) 
            {
                index = i*2+2;
                // real_value   
                data_[index] = input[i+1]; 
                //-complex_value
                data_[index+1] = -input[nn-i-1]; 
                                     
            }                                                                                                                                
            
        } 
        else if(isign == -1) 
        {
            
            /* Put the nyquist entry into the last array element */
            //input[nn] = input[1];
            
            /* Zero the imaginary parts of nyquist and DC */
            //input[nn+1] = input[1] = 0;
            
            /* Reverse plan */
            //plan = fftw_plan_r2r_1d(nn, input, output, FFTW_HC2R, FFTW_MEASURE);
            
            /* Execute FFT */
            //fftw_execute(plan);
            
            /* Copy output into data */
            //memcpy((void*)data,(const void*)output,(size_t)(nn * sizeof(double)));
            
            /* Try scaling */
            /* Multiply by scaling factor to restore NR conventions */
            //for(i = 0; i < nn; i++) data[i] *= 0.5;
            
        }	
        fftw_free(input);
    }
}
